function weather_map = importweather(filename, dataLines)
%IMPORTFILE Import data from a text file
%  R001 = IMPORTFILE(FILENAME) reads data from text file FILENAME for
%  the default selection.  Returns the numeric data.
%
%  R001 = IMPORTFILE(FILE, DATALINES) reads data for the specified row
%  interval(s) of text file FILENAME. Specify DATALINES as a positive
%  scalar integer or a N-by-2 array of positive scalar integers for
%  dis-contiguous row intervals.
%
%  Example:
%  R001 = importfile("C:\Users\hp\Desktop\Atmospheric_attenuation\R001.TXT", [1, Inf]);
%
%  See also READTABLE.
%
% Auto-generated by MATLAB on 17-Aug-2022 14:32:44

%% Input handling

% If dataLines is not specified, define defaults
if nargin < 2
    dataLines = [1, Inf];
end

%% Set up the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 2881);

% Specify range and delimiter
opts.DataLines = dataLines;
opts.Delimiter = ["\t", " "];

% Specify column names and types
opts.VariableNames = ["VarName1", "VarName2", "VarName3", "VarName4", "VarName5", "VarName6", "VarName7", "VarName8", "VarName9", "VarName10", "VarName11", "VarName12", "VarName13", "VarName14", "VarName15", "VarName16", "VarName17", "VarName18", "VarName19", "VarName20", "VarName21", "VarName22", "VarName23", "VarName24", "VarName25", "VarName26", "VarName27", "VarName28", "VarName29", "VarName30", "VarName31", "VarName32", "VarName33", "VarName34", "VarName35", "VarName36", "VarName37", "VarName38", "VarName39", "VarName40", "VarName41", "VarName42", "VarName43", "VarName44", "VarName45", "VarName46", "VarName47", "VarName48", "VarName49", "VarName50", "VarName51", "VarName52", "VarName53", "VarName54", "VarName55", "VarName56", "VarName57", "VarName58", "VarName59", "VarName60", "VarName61", "VarName62", "VarName63", "VarName64", "VarName65", "VarName66", "VarName67", "VarName68", "VarName69", "VarName70", "VarName71", "VarName72", "VarName73", "VarName74", "VarName75", "VarName76", "VarName77", "VarName78", "VarName79", "VarName80", "VarName81", "VarName82", "VarName83", "VarName84", "VarName85", "VarName86", "VarName87", "VarName88", "VarName89", "VarName90", "VarName91", "VarName92", "VarName93", "VarName94", "VarName95", "VarName96", "VarName97", "VarName98", "VarName99", "VarName100", "VarName101", "VarName102", "VarName103", "VarName104", "VarName105", "VarName106", "VarName107", "VarName108", "VarName109", "VarName110", "VarName111", "VarName112", "VarName113", "VarName114", "VarName115", "VarName116", "VarName117", "VarName118", "VarName119", "VarName120", "VarName121", "VarName122", "VarName123", "VarName124", "VarName125", "VarName126", "VarName127", "VarName128", "VarName129", "VarName130", "VarName131", "VarName132", "VarName133", "VarName134", "VarName135", "VarName136", "VarName137", "VarName138", "VarName139", "VarName140", "VarName141", "VarName142", "VarName143", "VarName144", "VarName145", "VarName146", "VarName147", "VarName148", "VarName149", "VarName150", "VarName151", "VarName152", "VarName153", "VarName154", "VarName155", "VarName156", "VarName157", "VarName158", "VarName159", "VarName160", "VarName161", "VarName162", "VarName163", "VarName164", "VarName165", "VarName166", "VarName167", "VarName168", "VarName169", "VarName170", "VarName171", "VarName172", "VarName173", "VarName174", "VarName175", "VarName176", "VarName177", "VarName178", "VarName179", "VarName180", "VarName181", "VarName182", "VarName183", "VarName184", "VarName185", "VarName186", "VarName187", "VarName188", "VarName189", "VarName190", "VarName191", "VarName192", "VarName193", "VarName194", "VarName195", "VarName196", "VarName197", "VarName198", "VarName199", "VarName200", "VarName201", "VarName202", "VarName203", "VarName204", "VarName205", "VarName206", "VarName207", "VarName208", "VarName209", "VarName210", "VarName211", "VarName212", "VarName213", "VarName214", "VarName215", "VarName216", "VarName217", "VarName218", "VarName219", "VarName220", "VarName221", "VarName222", "VarName223", "VarName224", "VarName225", "VarName226", "VarName227", "VarName228", "VarName229", "VarName230", "VarName231", "VarName232", "VarName233", "VarName234", "VarName235", "VarName236", "VarName237", "VarName238", "VarName239", "VarName240", "VarName241", "VarName242", "VarName243", "VarName244", "VarName245", "VarName246", "VarName247", "VarName248", "VarName249", "VarName250", "VarName251", "VarName252", "VarName253", "VarName254", "VarName255", "VarName256", "VarName257", "VarName258", "VarName259", "VarName260", "VarName261", "VarName262", "VarName263", "VarName264", "VarName265", "VarName266", "VarName267", "VarName268", "VarName269", "VarName270", "VarName271", "VarName272", "VarName273", "VarName274", "VarName275", "VarName276", "VarName277", "VarName278", "VarName279", "VarName280", "VarName281", "VarName282", "VarName283", "VarName284", "VarName285", "VarName286", "VarName287", "VarName288", "VarName289", "VarName290", "VarName291", "VarName292", "VarName293", "VarName294", "VarName295", "VarName296", "VarName297", "VarName298", "VarName299", "VarName300", "VarName301", "VarName302", "VarName303", "VarName304", "VarName305", "VarName306", "VarName307", "VarName308", "VarName309", "VarName310", "VarName311", "VarName312", "VarName313", "VarName314", "VarName315", "VarName316", "VarName317", "VarName318", "VarName319", "VarName320", "VarName321", "VarName322", "VarName323", "VarName324", "VarName325", "VarName326", "VarName327", "VarName328", "VarName329", "VarName330", "VarName331", "VarName332", "VarName333", "VarName334", "VarName335", "VarName336", "VarName337", "VarName338", "VarName339", "VarName340", "VarName341", "VarName342", "VarName343", "VarName344", "VarName345", "VarName346", "VarName347", "VarName348", "VarName349", "VarName350", "VarName351", "VarName352", "VarName353", "VarName354", "VarName355", "VarName356", "VarName357", "VarName358", "VarName359", "VarName360", "VarName361", "VarName362", "VarName363", "VarName364", "VarName365", "VarName366", "VarName367", "VarName368", "VarName369", "VarName370", "VarName371", "VarName372", "VarName373", "VarName374", "VarName375", "VarName376", "VarName377", "VarName378", "VarName379", "VarName380", "VarName381", "VarName382", "VarName383", "VarName384", "VarName385", "VarName386", "VarName387", "VarName388", "VarName389", "VarName390", "VarName391", "VarName392", "VarName393", "VarName394", "VarName395", "VarName396", "VarName397", "VarName398", "VarName399", "VarName400", "VarName401", "VarName402", "VarName403", "VarName404", "VarName405", "VarName406", "VarName407", "VarName408", "VarName409", "VarName410", "VarName411", "VarName412", "VarName413", "VarName414", "VarName415", "VarName416", "VarName417", "VarName418", "VarName419", "VarName420", "VarName421", "VarName422", "VarName423", "VarName424", "VarName425", "VarName426", "VarName427", "VarName428", "VarName429", "VarName430", "VarName431", "VarName432", "VarName433", "VarName434", "VarName435", "VarName436", "VarName437", "VarName438", "VarName439", "VarName440", "VarName441", "VarName442", "VarName443", "VarName444", "VarName445", "VarName446", "VarName447", "VarName448", "VarName449", "VarName450", "VarName451", "VarName452", "VarName453", "VarName454", "VarName455", "VarName456", "VarName457", "VarName458", "VarName459", "VarName460", "VarName461", "VarName462", "VarName463", "VarName464", "VarName465", "VarName466", "VarName467", "VarName468", "VarName469", "VarName470", "VarName471", "VarName472", "VarName473", "VarName474", "VarName475", "VarName476", "VarName477", "VarName478", "VarName479", "VarName480", "VarName481", "VarName482", "VarName483", "VarName484", "VarName485", "VarName486", "VarName487", "VarName488", "VarName489", "VarName490", "VarName491", "VarName492", "VarName493", "VarName494", "VarName495", "VarName496", "VarName497", "VarName498", "VarName499", "VarName500", "VarName501", "VarName502", "VarName503", "VarName504", "VarName505", "VarName506", "VarName507", "VarName508", "VarName509", "VarName510", "VarName511", "VarName512", "VarName513", "VarName514", "VarName515", "VarName516", "VarName517", "VarName518", "VarName519", "VarName520", "VarName521", "VarName522", "VarName523", "VarName524", "VarName525", "VarName526", "VarName527", "VarName528", "VarName529", "VarName530", "VarName531", "VarName532", "VarName533", "VarName534", "VarName535", "VarName536", "VarName537", "VarName538", "VarName539", "VarName540", "VarName541", "VarName542", "VarName543", "VarName544", "VarName545", "VarName546", "VarName547", "VarName548", "VarName549", "VarName550", "VarName551", "VarName552", "VarName553", "VarName554", "VarName555", "VarName556", "VarName557", "VarName558", "VarName559", "VarName560", "VarName561", "VarName562", "VarName563", "VarName564", "VarName565", "VarName566", "VarName567", "VarName568", "VarName569", "VarName570", "VarName571", "VarName572", "VarName573", "VarName574", "VarName575", "VarName576", "VarName577", "VarName578", "VarName579", "VarName580", "VarName581", "VarName582", "VarName583", "VarName584", "VarName585", "VarName586", "VarName587", "VarName588", "VarName589", "VarName590", "VarName591", "VarName592", "VarName593", "VarName594", "VarName595", "VarName596", "VarName597", "VarName598", "VarName599", "VarName600", "VarName601", "VarName602", "VarName603", "VarName604", "VarName605", "VarName606", "VarName607", "VarName608", "VarName609", "VarName610", "VarName611", "VarName612", "VarName613", "VarName614", "VarName615", "VarName616", "VarName617", "VarName618", "VarName619", "VarName620", "VarName621", "VarName622", "VarName623", "VarName624", "VarName625", "VarName626", "VarName627", "VarName628", "VarName629", "VarName630", "VarName631", "VarName632", "VarName633", "VarName634", "VarName635", "VarName636", "VarName637", "VarName638", "VarName639", "VarName640", "VarName641", "VarName642", "VarName643", "VarName644", "VarName645", "VarName646", "VarName647", "VarName648", "VarName649", "VarName650", "VarName651", "VarName652", "VarName653", "VarName654", "VarName655", "VarName656", "VarName657", "VarName658", "VarName659", "VarName660", "VarName661", "VarName662", "VarName663", "VarName664", "VarName665", "VarName666", "VarName667", "VarName668", "VarName669", "VarName670", "VarName671", "VarName672", "VarName673", "VarName674", "VarName675", "VarName676", "VarName677", "VarName678", "VarName679", "VarName680", "VarName681", "VarName682", "VarName683", "VarName684", "VarName685", "VarName686", "VarName687", "VarName688", "VarName689", "VarName690", "VarName691", "VarName692", "VarName693", "VarName694", "VarName695", "VarName696", "VarName697", "VarName698", "VarName699", "VarName700", "VarName701", "VarName702", "VarName703", "VarName704", "VarName705", "VarName706", "VarName707", "VarName708", "VarName709", "VarName710", "VarName711", "VarName712", "VarName713", "VarName714", "VarName715", "VarName716", "VarName717", "VarName718", "VarName719", "VarName720", "VarName721", "VarName722", "VarName723", "VarName724", "VarName725", "VarName726", "VarName727", "VarName728", "VarName729", "VarName730", "VarName731", "VarName732", "VarName733", "VarName734", "VarName735", "VarName736", "VarName737", "VarName738", "VarName739", "VarName740", "VarName741", "VarName742", "VarName743", "VarName744", "VarName745", "VarName746", "VarName747", "VarName748", "VarName749", "VarName750", "VarName751", "VarName752", "VarName753", "VarName754", "VarName755", "VarName756", "VarName757", "VarName758", "VarName759", "VarName760", "VarName761", "VarName762", "VarName763", "VarName764", "VarName765", "VarName766", "VarName767", "VarName768", "VarName769", "VarName770", "VarName771", "VarName772", "VarName773", "VarName774", "VarName775", "VarName776", "VarName777", "VarName778", "VarName779", "VarName780", "VarName781", "VarName782", "VarName783", "VarName784", "VarName785", "VarName786", "VarName787", "VarName788", "VarName789", "VarName790", "VarName791", "VarName792", "VarName793", "VarName794", "VarName795", "VarName796", "VarName797", "VarName798", "VarName799", "VarName800", "VarName801", "VarName802", "VarName803", "VarName804", "VarName805", "VarName806", "VarName807", "VarName808", "VarName809", "VarName810", "VarName811", "VarName812", "VarName813", "VarName814", "VarName815", "VarName816", "VarName817", "VarName818", "VarName819", "VarName820", "VarName821", "VarName822", "VarName823", "VarName824", "VarName825", "VarName826", "VarName827", "VarName828", "VarName829", "VarName830", "VarName831", "VarName832", "VarName833", "VarName834", "VarName835", "VarName836", "VarName837", "VarName838", "VarName839", "VarName840", "VarName841", "VarName842", "VarName843", "VarName844", "VarName845", "VarName846", "VarName847", "VarName848", "VarName849", "VarName850", "VarName851", "VarName852", "VarName853", "VarName854", "VarName855", "VarName856", "VarName857", "VarName858", "VarName859", "VarName860", "VarName861", "VarName862", "VarName863", "VarName864", "VarName865", "VarName866", "VarName867", "VarName868", "VarName869", "VarName870", "VarName871", "VarName872", "VarName873", "VarName874", "VarName875", "VarName876", "VarName877", "VarName878", "VarName879", "VarName880", "VarName881", "VarName882", "VarName883", "VarName884", "VarName885", "VarName886", "VarName887", "VarName888", "VarName889", "VarName890", "VarName891", "VarName892", "VarName893", "VarName894", "VarName895", "VarName896", "VarName897", "VarName898", "VarName899", "VarName900", "VarName901", "VarName902", "VarName903", "VarName904", "VarName905", "VarName906", "VarName907", "VarName908", "VarName909", "VarName910", "VarName911", "VarName912", "VarName913", "VarName914", "VarName915", "VarName916", "VarName917", "VarName918", "VarName919", "VarName920", "VarName921", "VarName922", "VarName923", "VarName924", "VarName925", "VarName926", "VarName927", "VarName928", "VarName929", "VarName930", "VarName931", "VarName932", "VarName933", "VarName934", "VarName935", "VarName936", "VarName937", "VarName938", "VarName939", "VarName940", "VarName941", "VarName942", "VarName943", "VarName944", "VarName945", "VarName946", "VarName947", "VarName948", "VarName949", "VarName950", "VarName951", "VarName952", "VarName953", "VarName954", "VarName955", "VarName956", "VarName957", "VarName958", "VarName959", "VarName960", "VarName961", "VarName962", "VarName963", "VarName964", "VarName965", "VarName966", "VarName967", "VarName968", "VarName969", "VarName970", "VarName971", "VarName972", "VarName973", "VarName974", "VarName975", "VarName976", "VarName977", "VarName978", "VarName979", "VarName980", "VarName981", "VarName982", "VarName983", "VarName984", "VarName985", "VarName986", "VarName987", "VarName988", "VarName989", "VarName990", "VarName991", "VarName992", "VarName993", "VarName994", "VarName995", "VarName996", "VarName997", "VarName998", "VarName999", "VarName1000", "VarName1001", "VarName1002", "VarName1003", "VarName1004", "VarName1005", "VarName1006", "VarName1007", "VarName1008", "VarName1009", "VarName1010", "VarName1011", "VarName1012", "VarName1013", "VarName1014", "VarName1015", "VarName1016", "VarName1017", "VarName1018", "VarName1019", "VarName1020", "VarName1021", "VarName1022", "VarName1023", "VarName1024", "VarName1025", "VarName1026", "VarName1027", "VarName1028", "VarName1029", "VarName1030", "VarName1031", "VarName1032", "VarName1033", "VarName1034", "VarName1035", "VarName1036", "VarName1037", "VarName1038", "VarName1039", "VarName1040", "VarName1041", "VarName1042", "VarName1043", "VarName1044", "VarName1045", "VarName1046", "VarName1047", "VarName1048", "VarName1049", "VarName1050", "VarName1051", "VarName1052", "VarName1053", "VarName1054", "VarName1055", "VarName1056", "VarName1057", "VarName1058", "VarName1059", "VarName1060", "VarName1061", "VarName1062", "VarName1063", "VarName1064", "VarName1065", "VarName1066", "VarName1067", "VarName1068", "VarName1069", "VarName1070", "VarName1071", "VarName1072", "VarName1073", "VarName1074", "VarName1075", "VarName1076", "VarName1077", "VarName1078", "VarName1079", "VarName1080", "VarName1081", "VarName1082", "VarName1083", "VarName1084", "VarName1085", "VarName1086", "VarName1087", "VarName1088", "VarName1089", "VarName1090", "VarName1091", "VarName1092", "VarName1093", "VarName1094", "VarName1095", "VarName1096", "VarName1097", "VarName1098", "VarName1099", "VarName1100", "VarName1101", "VarName1102", "VarName1103", "VarName1104", "VarName1105", "VarName1106", "VarName1107", "VarName1108", "VarName1109", "VarName1110", "VarName1111", "VarName1112", "VarName1113", "VarName1114", "VarName1115", "VarName1116", "VarName1117", "VarName1118", "VarName1119", "VarName1120", "VarName1121", "VarName1122", "VarName1123", "VarName1124", "VarName1125", "VarName1126", "VarName1127", "VarName1128", "VarName1129", "VarName1130", "VarName1131", "VarName1132", "VarName1133", "VarName1134", "VarName1135", "VarName1136", "VarName1137", "VarName1138", "VarName1139", "VarName1140", "VarName1141", "VarName1142", "VarName1143", "VarName1144", "VarName1145", "VarName1146", "VarName1147", "VarName1148", "VarName1149", "VarName1150", "VarName1151", "VarName1152", "VarName1153", "VarName1154", "VarName1155", "VarName1156", "VarName1157", "VarName1158", "VarName1159", "VarName1160", "VarName1161", "VarName1162", "VarName1163", "VarName1164", "VarName1165", "VarName1166", "VarName1167", "VarName1168", "VarName1169", "VarName1170", "VarName1171", "VarName1172", "VarName1173", "VarName1174", "VarName1175", "VarName1176", "VarName1177", "VarName1178", "VarName1179", "VarName1180", "VarName1181", "VarName1182", "VarName1183", "VarName1184", "VarName1185", "VarName1186", "VarName1187", "VarName1188", "VarName1189", "VarName1190", "VarName1191", "VarName1192", "VarName1193", "VarName1194", "VarName1195", "VarName1196", "VarName1197", "VarName1198", "VarName1199", "VarName1200", "VarName1201", "VarName1202", "VarName1203", "VarName1204", "VarName1205", "VarName1206", "VarName1207", "VarName1208", "VarName1209", "VarName1210", "VarName1211", "VarName1212", "VarName1213", "VarName1214", "VarName1215", "VarName1216", "VarName1217", "VarName1218", "VarName1219", "VarName1220", "VarName1221", "VarName1222", "VarName1223", "VarName1224", "VarName1225", "VarName1226", "VarName1227", "VarName1228", "VarName1229", "VarName1230", "VarName1231", "VarName1232", "VarName1233", "VarName1234", "VarName1235", "VarName1236", "VarName1237", "VarName1238", "VarName1239", "VarName1240", "VarName1241", "VarName1242", "VarName1243", "VarName1244", "VarName1245", "VarName1246", "VarName1247", "VarName1248", "VarName1249", "VarName1250", "VarName1251", "VarName1252", "VarName1253", "VarName1254", "VarName1255", "VarName1256", "VarName1257", "VarName1258", "VarName1259", "VarName1260", "VarName1261", "VarName1262", "VarName1263", "VarName1264", "VarName1265", "VarName1266", "VarName1267", "VarName1268", "VarName1269", "VarName1270", "VarName1271", "VarName1272", "VarName1273", "VarName1274", "VarName1275", "VarName1276", "VarName1277", "VarName1278", "VarName1279", "VarName1280", "VarName1281", "VarName1282", "VarName1283", "VarName1284", "VarName1285", "VarName1286", "VarName1287", "VarName1288", "VarName1289", "VarName1290", "VarName1291", "VarName1292", "VarName1293", "VarName1294", "VarName1295", "VarName1296", "VarName1297", "VarName1298", "VarName1299", "VarName1300", "VarName1301", "VarName1302", "VarName1303", "VarName1304", "VarName1305", "VarName1306", "VarName1307", "VarName1308", "VarName1309", "VarName1310", "VarName1311", "VarName1312", "VarName1313", "VarName1314", "VarName1315", "VarName1316", "VarName1317", "VarName1318", "VarName1319", "VarName1320", "VarName1321", "VarName1322", "VarName1323", "VarName1324", "VarName1325", "VarName1326", "VarName1327", "VarName1328", "VarName1329", "VarName1330", "VarName1331", "VarName1332", "VarName1333", "VarName1334", "VarName1335", "VarName1336", "VarName1337", "VarName1338", "VarName1339", "VarName1340", "VarName1341", "VarName1342", "VarName1343", "VarName1344", "VarName1345", "VarName1346", "VarName1347", "VarName1348", "VarName1349", "VarName1350", "VarName1351", "VarName1352", "VarName1353", "VarName1354", "VarName1355", "VarName1356", "VarName1357", "VarName1358", "VarName1359", "VarName1360", "VarName1361", "VarName1362", "VarName1363", "VarName1364", "VarName1365", "VarName1366", "VarName1367", "VarName1368", "VarName1369", "VarName1370", "VarName1371", "VarName1372", "VarName1373", "VarName1374", "VarName1375", "VarName1376", "VarName1377", "VarName1378", "VarName1379", "VarName1380", "VarName1381", "VarName1382", "VarName1383", "VarName1384", "VarName1385", "VarName1386", "VarName1387", "VarName1388", "VarName1389", "VarName1390", "VarName1391", "VarName1392", "VarName1393", "VarName1394", "VarName1395", "VarName1396", "VarName1397", "VarName1398", "VarName1399", "VarName1400", "VarName1401", "VarName1402", "VarName1403", "VarName1404", "VarName1405", "VarName1406", "VarName1407", "VarName1408", "VarName1409", "VarName1410", "VarName1411", "VarName1412", "VarName1413", "VarName1414", "VarName1415", "VarName1416", "VarName1417", "VarName1418", "VarName1419", "VarName1420", "VarName1421", "VarName1422", "VarName1423", "VarName1424", "VarName1425", "VarName1426", "VarName1427", "VarName1428", "VarName1429", "VarName1430", "VarName1431", "VarName1432", "VarName1433", "VarName1434", "VarName1435", "VarName1436", "VarName1437", "VarName1438", "VarName1439", "VarName1440", "VarName1441", "VarName1442", "VarName1443", "VarName1444", "VarName1445", "VarName1446", "VarName1447", "VarName1448", "VarName1449", "VarName1450", "VarName1451", "VarName1452", "VarName1453", "VarName1454", "VarName1455", "VarName1456", "VarName1457", "VarName1458", "VarName1459", "VarName1460", "VarName1461", "VarName1462", "VarName1463", "VarName1464", "VarName1465", "VarName1466", "VarName1467", "VarName1468", "VarName1469", "VarName1470", "VarName1471", "VarName1472", "VarName1473", "VarName1474", "VarName1475", "VarName1476", "VarName1477", "VarName1478", "VarName1479", "VarName1480", "VarName1481", "VarName1482", "VarName1483", "VarName1484", "VarName1485", "VarName1486", "VarName1487", "VarName1488", "VarName1489", "VarName1490", "VarName1491", "VarName1492", "VarName1493", "VarName1494", "VarName1495", "VarName1496", "VarName1497", "VarName1498", "VarName1499", "VarName1500", "VarName1501", "VarName1502", "VarName1503", "VarName1504", "VarName1505", "VarName1506", "VarName1507", "VarName1508", "VarName1509", "VarName1510", "VarName1511", "VarName1512", "VarName1513", "VarName1514", "VarName1515", "VarName1516", "VarName1517", "VarName1518", "VarName1519", "VarName1520", "VarName1521", "VarName1522", "VarName1523", "VarName1524", "VarName1525", "VarName1526", "VarName1527", "VarName1528", "VarName1529", "VarName1530", "VarName1531", "VarName1532", "VarName1533", "VarName1534", "VarName1535", "VarName1536", "VarName1537", "VarName1538", "VarName1539", "VarName1540", "VarName1541", "VarName1542", "VarName1543", "VarName1544", "VarName1545", "VarName1546", "VarName1547", "VarName1548", "VarName1549", "VarName1550", "VarName1551", "VarName1552", "VarName1553", "VarName1554", "VarName1555", "VarName1556", "VarName1557", "VarName1558", "VarName1559", "VarName1560", "VarName1561", "VarName1562", "VarName1563", "VarName1564", "VarName1565", "VarName1566", "VarName1567", "VarName1568", "VarName1569", "VarName1570", "VarName1571", "VarName1572", "VarName1573", "VarName1574", "VarName1575", "VarName1576", "VarName1577", "VarName1578", "VarName1579", "VarName1580", "VarName1581", "VarName1582", "VarName1583", "VarName1584", "VarName1585", "VarName1586", "VarName1587", "VarName1588", "VarName1589", "VarName1590", "VarName1591", "VarName1592", "VarName1593", "VarName1594", "VarName1595", "VarName1596", "VarName1597", "VarName1598", "VarName1599", "VarName1600", "VarName1601", "VarName1602", "VarName1603", "VarName1604", "VarName1605", "VarName1606", "VarName1607", "VarName1608", "VarName1609", "VarName1610", "VarName1611", "VarName1612", "VarName1613", "VarName1614", "VarName1615", "VarName1616", "VarName1617", "VarName1618", "VarName1619", "VarName1620", "VarName1621", "VarName1622", "VarName1623", "VarName1624", "VarName1625", "VarName1626", "VarName1627", "VarName1628", "VarName1629", "VarName1630", "VarName1631", "VarName1632", "VarName1633", "VarName1634", "VarName1635", "VarName1636", "VarName1637", "VarName1638", "VarName1639", "VarName1640", "VarName1641", "VarName1642", "VarName1643", "VarName1644", "VarName1645", "VarName1646", "VarName1647", "VarName1648", "VarName1649", "VarName1650", "VarName1651", "VarName1652", "VarName1653", "VarName1654", "VarName1655", "VarName1656", "VarName1657", "VarName1658", "VarName1659", "VarName1660", "VarName1661", "VarName1662", "VarName1663", "VarName1664", "VarName1665", "VarName1666", "VarName1667", "VarName1668", "VarName1669", "VarName1670", "VarName1671", "VarName1672", "VarName1673", "VarName1674", "VarName1675", "VarName1676", "VarName1677", "VarName1678", "VarName1679", "VarName1680", "VarName1681", "VarName1682", "VarName1683", "VarName1684", "VarName1685", "VarName1686", "VarName1687", "VarName1688", "VarName1689", "VarName1690", "VarName1691", "VarName1692", "VarName1693", "VarName1694", "VarName1695", "VarName1696", "VarName1697", "VarName1698", "VarName1699", "VarName1700", "VarName1701", "VarName1702", "VarName1703", "VarName1704", "VarName1705", "VarName1706", "VarName1707", "VarName1708", "VarName1709", "VarName1710", "VarName1711", "VarName1712", "VarName1713", "VarName1714", "VarName1715", "VarName1716", "VarName1717", "VarName1718", "VarName1719", "VarName1720", "VarName1721", "VarName1722", "VarName1723", "VarName1724", "VarName1725", "VarName1726", "VarName1727", "VarName1728", "VarName1729", "VarName1730", "VarName1731", "VarName1732", "VarName1733", "VarName1734", "VarName1735", "VarName1736", "VarName1737", "VarName1738", "VarName1739", "VarName1740", "VarName1741", "VarName1742", "VarName1743", "VarName1744", "VarName1745", "VarName1746", "VarName1747", "VarName1748", "VarName1749", "VarName1750", "VarName1751", "VarName1752", "VarName1753", "VarName1754", "VarName1755", "VarName1756", "VarName1757", "VarName1758", "VarName1759", "VarName1760", "VarName1761", "VarName1762", "VarName1763", "VarName1764", "VarName1765", "VarName1766", "VarName1767", "VarName1768", "VarName1769", "VarName1770", "VarName1771", "VarName1772", "VarName1773", "VarName1774", "VarName1775", "VarName1776", "VarName1777", "VarName1778", "VarName1779", "VarName1780", "VarName1781", "VarName1782", "VarName1783", "VarName1784", "VarName1785", "VarName1786", "VarName1787", "VarName1788", "VarName1789", "VarName1790", "VarName1791", "VarName1792", "VarName1793", "VarName1794", "VarName1795", "VarName1796", "VarName1797", "VarName1798", "VarName1799", "VarName1800", "VarName1801", "VarName1802", "VarName1803", "VarName1804", "VarName1805", "VarName1806", "VarName1807", "VarName1808", "VarName1809", "VarName1810", "VarName1811", "VarName1812", "VarName1813", "VarName1814", "VarName1815", "VarName1816", "VarName1817", "VarName1818", "VarName1819", "VarName1820", "VarName1821", "VarName1822", "VarName1823", "VarName1824", "VarName1825", "VarName1826", "VarName1827", "VarName1828", "VarName1829", "VarName1830", "VarName1831", "VarName1832", "VarName1833", "VarName1834", "VarName1835", "VarName1836", "VarName1837", "VarName1838", "VarName1839", "VarName1840", "VarName1841", "VarName1842", "VarName1843", "VarName1844", "VarName1845", "VarName1846", "VarName1847", "VarName1848", "VarName1849", "VarName1850", "VarName1851", "VarName1852", "VarName1853", "VarName1854", "VarName1855", "VarName1856", "VarName1857", "VarName1858", "VarName1859", "VarName1860", "VarName1861", "VarName1862", "VarName1863", "VarName1864", "VarName1865", "VarName1866", "VarName1867", "VarName1868", "VarName1869", "VarName1870", "VarName1871", "VarName1872", "VarName1873", "VarName1874", "VarName1875", "VarName1876", "VarName1877", "VarName1878", "VarName1879", "VarName1880", "VarName1881", "VarName1882", "VarName1883", "VarName1884", "VarName1885", "VarName1886", "VarName1887", "VarName1888", "VarName1889", "VarName1890", "VarName1891", "VarName1892", "VarName1893", "VarName1894", "VarName1895", "VarName1896", "VarName1897", "VarName1898", "VarName1899", "VarName1900", "VarName1901", "VarName1902", "VarName1903", "VarName1904", "VarName1905", "VarName1906", "VarName1907", "VarName1908", "VarName1909", "VarName1910", "VarName1911", "VarName1912", "VarName1913", "VarName1914", "VarName1915", "VarName1916", "VarName1917", "VarName1918", "VarName1919", "VarName1920", "VarName1921", "VarName1922", "VarName1923", "VarName1924", "VarName1925", "VarName1926", "VarName1927", "VarName1928", "VarName1929", "VarName1930", "VarName1931", "VarName1932", "VarName1933", "VarName1934", "VarName1935", "VarName1936", "VarName1937", "VarName1938", "VarName1939", "VarName1940", "VarName1941", "VarName1942", "VarName1943", "VarName1944", "VarName1945", "VarName1946", "VarName1947", "VarName1948", "VarName1949", "VarName1950", "VarName1951", "VarName1952", "VarName1953", "VarName1954", "VarName1955", "VarName1956", "VarName1957", "VarName1958", "VarName1959", "VarName1960", "VarName1961", "VarName1962", "VarName1963", "VarName1964", "VarName1965", "VarName1966", "VarName1967", "VarName1968", "VarName1969", "VarName1970", "VarName1971", "VarName1972", "VarName1973", "VarName1974", "VarName1975", "VarName1976", "VarName1977", "VarName1978", "VarName1979", "VarName1980", "VarName1981", "VarName1982", "VarName1983", "VarName1984", "VarName1985", "VarName1986", "VarName1987", "VarName1988", "VarName1989", "VarName1990", "VarName1991", "VarName1992", "VarName1993", "VarName1994", "VarName1995", "VarName1996", "VarName1997", "VarName1998", "VarName1999", "VarName2000", "VarName2001", "VarName2002", "VarName2003", "VarName2004", "VarName2005", "VarName2006", "VarName2007", "VarName2008", "VarName2009", "VarName2010", "VarName2011", "VarName2012", "VarName2013", "VarName2014", "VarName2015", "VarName2016", "VarName2017", "VarName2018", "VarName2019", "VarName2020", "VarName2021", "VarName2022", "VarName2023", "VarName2024", "VarName2025", "VarName2026", "VarName2027", "VarName2028", "VarName2029", "VarName2030", "VarName2031", "VarName2032", "VarName2033", "VarName2034", "VarName2035", "VarName2036", "VarName2037", "VarName2038", "VarName2039", "VarName2040", "VarName2041", "VarName2042", "VarName2043", "VarName2044", "VarName2045", "VarName2046", "VarName2047", "VarName2048", "VarName2049", "VarName2050", "VarName2051", "VarName2052", "VarName2053", "VarName2054", "VarName2055", "VarName2056", "VarName2057", "VarName2058", "VarName2059", "VarName2060", "VarName2061", "VarName2062", "VarName2063", "VarName2064", "VarName2065", "VarName2066", "VarName2067", "VarName2068", "VarName2069", "VarName2070", "VarName2071", "VarName2072", "VarName2073", "VarName2074", "VarName2075", "VarName2076", "VarName2077", "VarName2078", "VarName2079", "VarName2080", "VarName2081", "VarName2082", "VarName2083", "VarName2084", "VarName2085", "VarName2086", "VarName2087", "VarName2088", "VarName2089", "VarName2090", "VarName2091", "VarName2092", "VarName2093", "VarName2094", "VarName2095", "VarName2096", "VarName2097", "VarName2098", "VarName2099", "VarName2100", "VarName2101", "VarName2102", "VarName2103", "VarName2104", "VarName2105", "VarName2106", "VarName2107", "VarName2108", "VarName2109", "VarName2110", "VarName2111", "VarName2112", "VarName2113", "VarName2114", "VarName2115", "VarName2116", "VarName2117", "VarName2118", "VarName2119", "VarName2120", "VarName2121", "VarName2122", "VarName2123", "VarName2124", "VarName2125", "VarName2126", "VarName2127", "VarName2128", "VarName2129", "VarName2130", "VarName2131", "VarName2132", "VarName2133", "VarName2134", "VarName2135", "VarName2136", "VarName2137", "VarName2138", "VarName2139", "VarName2140", "VarName2141", "VarName2142", "VarName2143", "VarName2144", "VarName2145", "VarName2146", "VarName2147", "VarName2148", "VarName2149", "VarName2150", "VarName2151", "VarName2152", "VarName2153", "VarName2154", "VarName2155", "VarName2156", "VarName2157", "VarName2158", "VarName2159", "VarName2160", "VarName2161", "VarName2162", "VarName2163", "VarName2164", "VarName2165", "VarName2166", "VarName2167", "VarName2168", "VarName2169", "VarName2170", "VarName2171", "VarName2172", "VarName2173", "VarName2174", "VarName2175", "VarName2176", "VarName2177", "VarName2178", "VarName2179", "VarName2180", "VarName2181", "VarName2182", "VarName2183", "VarName2184", "VarName2185", "VarName2186", "VarName2187", "VarName2188", "VarName2189", "VarName2190", "VarName2191", "VarName2192", "VarName2193", "VarName2194", "VarName2195", "VarName2196", "VarName2197", "VarName2198", "VarName2199", "VarName2200", "VarName2201", "VarName2202", "VarName2203", "VarName2204", "VarName2205", "VarName2206", "VarName2207", "VarName2208", "VarName2209", "VarName2210", "VarName2211", "VarName2212", "VarName2213", "VarName2214", "VarName2215", "VarName2216", "VarName2217", "VarName2218", "VarName2219", "VarName2220", "VarName2221", "VarName2222", "VarName2223", "VarName2224", "VarName2225", "VarName2226", "VarName2227", "VarName2228", "VarName2229", "VarName2230", "VarName2231", "VarName2232", "VarName2233", "VarName2234", "VarName2235", "VarName2236", "VarName2237", "VarName2238", "VarName2239", "VarName2240", "VarName2241", "VarName2242", "VarName2243", "VarName2244", "VarName2245", "VarName2246", "VarName2247", "VarName2248", "VarName2249", "VarName2250", "VarName2251", "VarName2252", "VarName2253", "VarName2254", "VarName2255", "VarName2256", "VarName2257", "VarName2258", "VarName2259", "VarName2260", "VarName2261", "VarName2262", "VarName2263", "VarName2264", "VarName2265", "VarName2266", "VarName2267", "VarName2268", "VarName2269", "VarName2270", "VarName2271", "VarName2272", "VarName2273", "VarName2274", "VarName2275", "VarName2276", "VarName2277", "VarName2278", "VarName2279", "VarName2280", "VarName2281", "VarName2282", "VarName2283", "VarName2284", "VarName2285", "VarName2286", "VarName2287", "VarName2288", "VarName2289", "VarName2290", "VarName2291", "VarName2292", "VarName2293", "VarName2294", "VarName2295", "VarName2296", "VarName2297", "VarName2298", "VarName2299", "VarName2300", "VarName2301", "VarName2302", "VarName2303", "VarName2304", "VarName2305", "VarName2306", "VarName2307", "VarName2308", "VarName2309", "VarName2310", "VarName2311", "VarName2312", "VarName2313", "VarName2314", "VarName2315", "VarName2316", "VarName2317", "VarName2318", "VarName2319", "VarName2320", "VarName2321", "VarName2322", "VarName2323", "VarName2324", "VarName2325", "VarName2326", "VarName2327", "VarName2328", "VarName2329", "VarName2330", "VarName2331", "VarName2332", "VarName2333", "VarName2334", "VarName2335", "VarName2336", "VarName2337", "VarName2338", "VarName2339", "VarName2340", "VarName2341", "VarName2342", "VarName2343", "VarName2344", "VarName2345", "VarName2346", "VarName2347", "VarName2348", "VarName2349", "VarName2350", "VarName2351", "VarName2352", "VarName2353", "VarName2354", "VarName2355", "VarName2356", "VarName2357", "VarName2358", "VarName2359", "VarName2360", "VarName2361", "VarName2362", "VarName2363", "VarName2364", "VarName2365", "VarName2366", "VarName2367", "VarName2368", "VarName2369", "VarName2370", "VarName2371", "VarName2372", "VarName2373", "VarName2374", "VarName2375", "VarName2376", "VarName2377", "VarName2378", "VarName2379", "VarName2380", "VarName2381", "VarName2382", "VarName2383", "VarName2384", "VarName2385", "VarName2386", "VarName2387", "VarName2388", "VarName2389", "VarName2390", "VarName2391", "VarName2392", "VarName2393", "VarName2394", "VarName2395", "VarName2396", "VarName2397", "VarName2398", "VarName2399", "VarName2400", "VarName2401", "VarName2402", "VarName2403", "VarName2404", "VarName2405", "VarName2406", "VarName2407", "VarName2408", "VarName2409", "VarName2410", "VarName2411", "VarName2412", "VarName2413", "VarName2414", "VarName2415", "VarName2416", "VarName2417", "VarName2418", "VarName2419", "VarName2420", "VarName2421", "VarName2422", "VarName2423", "VarName2424", "VarName2425", "VarName2426", "VarName2427", "VarName2428", "VarName2429", "VarName2430", "VarName2431", "VarName2432", "VarName2433", "VarName2434", "VarName2435", "VarName2436", "VarName2437", "VarName2438", "VarName2439", "VarName2440", "VarName2441", "VarName2442", "VarName2443", "VarName2444", "VarName2445", "VarName2446", "VarName2447", "VarName2448", "VarName2449", "VarName2450", "VarName2451", "VarName2452", "VarName2453", "VarName2454", "VarName2455", "VarName2456", "VarName2457", "VarName2458", "VarName2459", "VarName2460", "VarName2461", "VarName2462", "VarName2463", "VarName2464", "VarName2465", "VarName2466", "VarName2467", "VarName2468", "VarName2469", "VarName2470", "VarName2471", "VarName2472", "VarName2473", "VarName2474", "VarName2475", "VarName2476", "VarName2477", "VarName2478", "VarName2479", "VarName2480", "VarName2481", "VarName2482", "VarName2483", "VarName2484", "VarName2485", "VarName2486", "VarName2487", "VarName2488", "VarName2489", "VarName2490", "VarName2491", "VarName2492", "VarName2493", "VarName2494", "VarName2495", "VarName2496", "VarName2497", "VarName2498", "VarName2499", "VarName2500", "VarName2501", "VarName2502", "VarName2503", "VarName2504", "VarName2505", "VarName2506", "VarName2507", "VarName2508", "VarName2509", "VarName2510", "VarName2511", "VarName2512", "VarName2513", "VarName2514", "VarName2515", "VarName2516", "VarName2517", "VarName2518", "VarName2519", "VarName2520", "VarName2521", "VarName2522", "VarName2523", "VarName2524", "VarName2525", "VarName2526", "VarName2527", "VarName2528", "VarName2529", "VarName2530", "VarName2531", "VarName2532", "VarName2533", "VarName2534", "VarName2535", "VarName2536", "VarName2537", "VarName2538", "VarName2539", "VarName2540", "VarName2541", "VarName2542", "VarName2543", "VarName2544", "VarName2545", "VarName2546", "VarName2547", "VarName2548", "VarName2549", "VarName2550", "VarName2551", "VarName2552", "VarName2553", "VarName2554", "VarName2555", "VarName2556", "VarName2557", "VarName2558", "VarName2559", "VarName2560", "VarName2561", "VarName2562", "VarName2563", "VarName2564", "VarName2565", "VarName2566", "VarName2567", "VarName2568", "VarName2569", "VarName2570", "VarName2571", "VarName2572", "VarName2573", "VarName2574", "VarName2575", "VarName2576", "VarName2577", "VarName2578", "VarName2579", "VarName2580", "VarName2581", "VarName2582", "VarName2583", "VarName2584", "VarName2585", "VarName2586", "VarName2587", "VarName2588", "VarName2589", "VarName2590", "VarName2591", "VarName2592", "VarName2593", "VarName2594", "VarName2595", "VarName2596", "VarName2597", "VarName2598", "VarName2599", "VarName2600", "VarName2601", "VarName2602", "VarName2603", "VarName2604", "VarName2605", "VarName2606", "VarName2607", "VarName2608", "VarName2609", "VarName2610", "VarName2611", "VarName2612", "VarName2613", "VarName2614", "VarName2615", "VarName2616", "VarName2617", "VarName2618", "VarName2619", "VarName2620", "VarName2621", "VarName2622", "VarName2623", "VarName2624", "VarName2625", "VarName2626", "VarName2627", "VarName2628", "VarName2629", "VarName2630", "VarName2631", "VarName2632", "VarName2633", "VarName2634", "VarName2635", "VarName2636", "VarName2637", "VarName2638", "VarName2639", "VarName2640", "VarName2641", "VarName2642", "VarName2643", "VarName2644", "VarName2645", "VarName2646", "VarName2647", "VarName2648", "VarName2649", "VarName2650", "VarName2651", "VarName2652", "VarName2653", "VarName2654", "VarName2655", "VarName2656", "VarName2657", "VarName2658", "VarName2659", "VarName2660", "VarName2661", "VarName2662", "VarName2663", "VarName2664", "VarName2665", "VarName2666", "VarName2667", "VarName2668", "VarName2669", "VarName2670", "VarName2671", "VarName2672", "VarName2673", "VarName2674", "VarName2675", "VarName2676", "VarName2677", "VarName2678", "VarName2679", "VarName2680", "VarName2681", "VarName2682", "VarName2683", "VarName2684", "VarName2685", "VarName2686", "VarName2687", "VarName2688", "VarName2689", "VarName2690", "VarName2691", "VarName2692", "VarName2693", "VarName2694", "VarName2695", "VarName2696", "VarName2697", "VarName2698", "VarName2699", "VarName2700", "VarName2701", "VarName2702", "VarName2703", "VarName2704", "VarName2705", "VarName2706", "VarName2707", "VarName2708", "VarName2709", "VarName2710", "VarName2711", "VarName2712", "VarName2713", "VarName2714", "VarName2715", "VarName2716", "VarName2717", "VarName2718", "VarName2719", "VarName2720", "VarName2721", "VarName2722", "VarName2723", "VarName2724", "VarName2725", "VarName2726", "VarName2727", "VarName2728", "VarName2729", "VarName2730", "VarName2731", "VarName2732", "VarName2733", "VarName2734", "VarName2735", "VarName2736", "VarName2737", "VarName2738", "VarName2739", "VarName2740", "VarName2741", "VarName2742", "VarName2743", "VarName2744", "VarName2745", "VarName2746", "VarName2747", "VarName2748", "VarName2749", "VarName2750", "VarName2751", "VarName2752", "VarName2753", "VarName2754", "VarName2755", "VarName2756", "VarName2757", "VarName2758", "VarName2759", "VarName2760", "VarName2761", "VarName2762", "VarName2763", "VarName2764", "VarName2765", "VarName2766", "VarName2767", "VarName2768", "VarName2769", "VarName2770", "VarName2771", "VarName2772", "VarName2773", "VarName2774", "VarName2775", "VarName2776", "VarName2777", "VarName2778", "VarName2779", "VarName2780", "VarName2781", "VarName2782", "VarName2783", "VarName2784", "VarName2785", "VarName2786", "VarName2787", "VarName2788", "VarName2789", "VarName2790", "VarName2791", "VarName2792", "VarName2793", "VarName2794", "VarName2795", "VarName2796", "VarName2797", "VarName2798", "VarName2799", "VarName2800", "VarName2801", "VarName2802", "VarName2803", "VarName2804", "VarName2805", "VarName2806", "VarName2807", "VarName2808", "VarName2809", "VarName2810", "VarName2811", "VarName2812", "VarName2813", "VarName2814", "VarName2815", "VarName2816", "VarName2817", "VarName2818", "VarName2819", "VarName2820", "VarName2821", "VarName2822", "VarName2823", "VarName2824", "VarName2825", "VarName2826", "VarName2827", "VarName2828", "VarName2829", "VarName2830", "VarName2831", "VarName2832", "VarName2833", "VarName2834", "VarName2835", "VarName2836", "VarName2837", "VarName2838", "VarName2839", "VarName2840", "VarName2841", "VarName2842", "VarName2843", "VarName2844", "VarName2845", "VarName2846", "VarName2847", "VarName2848", "VarName2849", "VarName2850", "VarName2851", "VarName2852", "VarName2853", "VarName2854", "VarName2855", "VarName2856", "VarName2857", "VarName2858", "VarName2859", "VarName2860", "VarName2861", "VarName2862", "VarName2863", "VarName2864", "VarName2865", "VarName2866", "VarName2867", "VarName2868", "VarName2869", "VarName2870", "VarName2871", "VarName2872", "VarName2873", "VarName2874", "VarName2875", "VarName2876", "VarName2877", "VarName2878", "VarName2879", "VarName2880", "VarName2881"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";
opts.ConsecutiveDelimitersRule = "join";

% Import the data
weather_map = readtable(filename, opts);

%% Convert to output type
weather_map = table2array(weather_map);
end